#ifndef __ACAMERA_H
#define __ACAMERA_H

class AstCamera
{
  private:
    AstFixedpoint_t vdf, hdf;         // distance factors used in projection
    int             vfov, hfov;       // field of view
    int             half_screen_width, half_screen_height;

    void SetHFOV( unsigned angle, int vport_width );
    void SetVFOV( unsigned angle, int vport_height );

    inline int HProject( AstFixedpoint_t value, AstFixedpoint_t z ) const;
    inline int VProject( AstFixedpoint_t value, AstFixedpoint_t z ) const;

  public:
    AstCamera( unsigned fov );

    void ProjectPoints( const AstVector *source_array,
                        AstScreenVertex *dest_array,
                        int num_vertices ) const;
};

#endif
