#ifndef __AOBJDEF_H
#define __AOBJDEF_H

class AstObjectDefinition
{
  private:
    AstTriangle     *triangle_array;
    AstVector       *vertex_array;
    AstScreenVertex *texture_vertex_array;
    bool             ccw;

    int              num_triangles;
    int              num_vertices;
    int              num_texture_vertices;
    bool             valid;

    bool         LoadFrom( const char *filename, AstFixedpoint_t scale_divisor );

    void         LoadVertices( FILE *fp );
    void         LoadTextureVertices( FILE *fp );
    void         LoadTriangles( FILE *fp );

  public:

    AstObjectDefinition( const char *filename, AstFixedpoint_t scale_divisor );
   ~AstObjectDefinition();

    bool  IsValid( void ) const { return valid; }

    const AstVector       &GetVertex( int v )   const { return vertex_array[v]; }
    const AstTriangle     &GetTriangle( int t ) const { return triangle_array[t]; }

    int GetNumTriangles( void ) const { return num_triangles; }
    int GetNumVertices( void ) const { return num_vertices; }

    void AssignTextureMap( AstTextureMap *map );
};

#endif
