#include "ast3d.h"

/*
** We declare our basic global variables here
*/
AstWorld     world;
AstConfig    config;
AstPlayer   *player;

/*
** These are our input devices
*/
Ast2DInputDevice *inputdevice2d;
AstGameport      *gameport;
AstRCS           *rcs;
AstWCS           *wcs;

/*
** This specifies a camera with a 60 degree field of view
*/
AstCamera camera( 600 );

/*
** Private function declarations
*/
void AstEnd( void );
void AstInit( int argc, const char *argv[] );

/*
** Some of the automatically allocated variables we use are
** pretty hefty in size, so if we're using Borland C++ we'll
** bump up the default stack a bit.
*/
#ifdef __BORLANDC__
extern unsigned _stklen = 8192;
#endif

/*
** main():  This is the program's main() function (duh)
*/
void main( int argc, const char *argv[] )
{
   AstInit( argc, argv );

   world.Run();

   AstEnd();
}

