#ifndef __AWORLD_H
#define __AWORLD_H

class AstWorld
{
  protected:

    static const int   max_visible_objects;
    int                num_visible_objects;
    AstObject        **visible_objects;

    struct {
       bool done;
    } state;

    AstObject  *object_list_head;
    AstVector   light_source;

    void CalculateVisibilities( void );
    void CheckCollisions( void );
    void DrawCrosshairs( void );
    void DrawObjectList( void );
    void SortObjectList( void );
    void UpdateObjectList( void );

  public:
    AstWorld( void );
   ~AstWorld();

    void Add( AstObject &o );

    const AstVector &GetLightSource( void ) const { return light_source; }
    void             SetLightSource( AstVector &v ) { light_source = v; }

    void Run( void );
    void Stop( void ) { state.done = true; }
};

#endif
