#include "ast3d.h"

static AstKeyboard _kbd;

AstKeyboard *keyboard = &_kbd;

#ifdef __BORLANDC__
#  define BIOSKEY(cmd) bioskey(cmd)
#else
#  define BIOSKEY(cmd) _bios_keybrd(cmd)
#endif

/*
** int AstKeyboard::GetKey( void )
**
** This routine returns the next key waiting to be grabbed from the
** keyboard.  If no key is enqueued then "KbdNoKey" is returned
** instead.
*/
int AstKeyboard::GetKey( void )
{
   if ( KeyWaiting() ) {
    int key = getch();

       if ( key )
          return key;
       else
          return getch() + 256;
   }
   else {
      return KbdNoKey;
   }
}

/*
** bool AstKeyboard::KeyWaiting( void ) const
**
** Returns true if there is a key waiting in the keyboard buffer,
** otherwise returns false.
*/
bool AstKeyboard::KeyWaiting( void ) const
{
   return ( kbhit() != 0 );
}

/*
** bool AstKeyboard::Shift( void ) const
**
** Returns true if there the shift key is being pressed, otherwise
** returns false.
*/
bool AstKeyboard::Shift( void ) const
{
   if ( BIOSKEY( _KEYBRD_SHIFTSTATUS ) & 0x03 )
      return true;
   return false;
}
