#include "ast3d.h"

AstTrigTable  *trig_table;

/*
** AstTrigTable::AstTrigTable( void )
**
** Builds the fixed point trigonometric table.
*/
AstTrigTable::AstTrigTable()
{
int i;

   for ( i = 0; i < TRIG_TABLE_SIZE/2; i++ ) {
      double radian = ( ( double ) i ) * ( 2.0 * M_PI ) / ( double ) TRIG_TABLE_SIZE;
      float result = sin( radian );
      data[i] = AstConvertToFix( result );
   }
   for ( i = 0; i < TRIG_TABLE_SIZE/2; i++ ) {
      data[i+TRIG_TABLE_SIZE/2] = data[i] * -1;
   }
}

